/*
   This program evaluates (interprets) an Abstract Syntax Tree (AST)
   that is defined by the following grammar.

       Prog ::= '(' 'prog' Define* Exp ')'

     Define ::= '(' 'define' VARIABLE Exp ')'
              | '(' 'define' FUNC-NAME Lambda ')'

     Lambda ::= '(' 'lambda' VARIABLE* Exp ')'

        Exp ::= Begin | Print | Var | While | NExp

      Begin ::= '(' 'begin' Exp  Exp+ ')'

      Print ::= '(' 'print' NExp ')'

      While ::= '(' 'while' BExp Exp ')'

       NExp ::= Set | AExp | BExp | Apply | If  | VARIABLE

         If ::= '(' 'if' BExp Exp Exp ')'

      Apply ::= '(' 'apply' FUNC-NAME NExp* ')'
              | '(' 'apply' Lambda NExp* ')'    // applying an anonymous function

        Var ::= '(' 'var' VARIABLE NExp ')'

        Set ::= '(' 'set' VARIABLE NExp ')'

       AExp ::= '(' BinOp NExp NExp ')'
              | '(' '+' NExp+ ')'
              | '(' '-' NExp ')'
              | '(' '-' NExp NExp ')'
              | '(' '*' NExp NExp+ ')'
              | INTEGER

     BinOp  ::= '\' | ' %' | '^'

       BExp ::= '(' BoolOp NExp NExp+ ')'
              | '(' '!' NExp ')'
              | '(' RelOp  NExp NExp ')'
              | '(' EquOp  NExp NExp ')'
              | BOOLEAN

     BoolOp ::= '&&' | '||'
     RelOp  ::= '<' | '>' | '<=' | '>='
     EquOp  ::= '==' | '!='

    INTEGER ::= [0-9]+
    BOOLEAN ::= 'true' | 'false'
   VARIABLE ::= [a-zA-Z][a-zA-Z0-9]*
  FUNC-NAME ::= [a-zA-Z][a-zA-Z0-9]*

*/

public class Evaluate
{
   // Global environment for function definitions.
   private static FunctionEnvironment funcEnv;
   // Global environment for variable definitions.
   private static Environment globalEnv;


   public static Value evaluate(Tree tree) throws EvalException
   {
      Value result = null;


      // implement this method


      return  result;
   }//evaluate()




}//Evaluate